<?php
/**
* 2007-2017 PrestaShop
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author    PrestaShop SA <contact@prestashop.com>
*  @copyright 2007-2017 PrestaShop SA
*  @license   http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*  International Registered Trademark & Property of PrestaShop SA
*/

if (!defined('_PS_VERSION_')) {
    exit;
}

class cdreferencetoid extends Module
{
    protected $config_form = false;

    public function __construct()
    {
        $this->name = 'cdreferencetoid';
        $this->tab = 'billing_invoicing';
        $this->version = '1.3.0';
        $this->author = 'Code Plus';
        $this->need_instance = 0;
        $this->module_key = 'b95967ad98e83a30966089b8a6c15658';

        /**
         * Set $this->bootstrap to true if your module is compliant with bootstrap (PrestaShop 1.6)
         */
        $this->bootstrap = true;

        parent::__construct();

        $this->displayName = $this->l('CodePlus Reference To Id');
        $this->description = $this->l('Update and change all references order to id orders');

        $this->ps_versions_compliancy = array('min' => '1.6', 'max' => _PS_VERSION_);
    }

    /**
     * Don't forget to create update methods if needed:
     * http://doc.prestashop.com/display/PS16/Enabling+the+Auto-Update
     */
    public function install()
    {
        Configuration::updateValue('CD_REFERENCETOID_LIVE_MODE', false);
        Db::getInstance()->execute("UPDATE "._DB_PREFIX_."orders SET reference = id_order");

        return parent::install() &&
            $this->registerHook('header') &&
            $this->registerHook('backOfficeHeader') &&
            $this->registerHook('actionValidateOrder');
    }

    public function uninstall()
    {
        Configuration::deleteByName('CDREFERENCETOID_LIVE_MODE');

        return parent::uninstall();
    }

    public function hookActionValidateOrder($params)
    {
        if (!$this->active)
            return false;

        $order_payment = new OrderPayment();
        $transaction_id = $order_payment->getByOrderReference($params['order']->reference);
        
        if(count($transaction_id)){
            foreach($transaction_id as $transaction){
                $transaction->order_reference = $$params['order']->id;
                $transaction->update();
            }
        }

        $params['order']->reference = $$params['order']->id;
        $params['order']->update();
    }
}
